<?php
######################################################################################
#  Copyright (C) 2010 NginxCP.com. All rights reserved.
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
######################################################################################

header("Content-Type: text/html\n\n");

// *** Common variables ***
$cpAppName = 'Nginx Admin';
$cpAppVersion = '1.6';

$user = getenv('REMOTE_USER');
if($user != "root") { echo "You do not have the proper permissions to access Nginx Admin..."; exit; }
function ejecutar($act) {
if($act == "restart") {
$var = shell_exec("/etc/init.d/httpd restart");
if(empty($var)) { echo "<p>Nginx Restarted Successfully.</p>"; } else { echo "<p>{$var}</p>"; }
} elseif($act == "rebuild") {
$var = shell_exec("/scripts/createvhost.py");
if(empty($var)) { echo "<p>Tast Completed Successfully.</p>"; } else { echo "<p>{$var}</p>"; }
}
}
?>
<html>
<head>
<title><?php echo $cpAppName; ?></title>
<meta name="description" content="WHM Plug-in of Nginx for cPanel servers" />
<link rel='stylesheet' type='text/css' href='/themes/x/style_optimized.css' />
<script type="text/javascript">
function okay() {
if(confirm('Are you sure of save configuration?')) {
document.getElementById('okay').submit();
}
return false;
}
function clog() {
document.getElementById('log').submit();
}
</script>
<style>
div#wrap {
margin: 0 auto;
width: 700px;
}
</style>
</head>
<body class="yui-skin-sam">
<div id="pageheader">
        <div id="breadcrumbs">
                <p>&nbsp;<a href="/scripts/command?PFILE=main">Main</a> &gt;&gt; <a href="nginx.php" class="active"><?php echo 
$cpAppName; ?></a></p>
        </div>
<div id="doctitle"><h1><?php echo $cpAppName; ?> (v<?php echo $cpAppVersion; ?>)</h1></div>
</div>
<div id="wrap">
<table cellpadding="0" cellspacing="0">
<tr align="center">
<td width="180"><img src="restartservices.gif" alt="Restart Nginx" /></td>
<td width="180"><img src="config.png" alt="Nginx Configuration Editor" /></td>
<td width="180"><img src="rebuild.png" alt="Rebuild VHosts" /></td>
<td width="180"><img src="log.png" alt="View Nginx Log" /></td>
</tr>
<tr align="center">
<td><a href="nginx.php?op=restart">Restart Nginx</a></td>
<td><a href="nginx.php?op=edit">Configuration Editor</a></td>
<td><a href="nginx.php?op=rebuild">Rebuild Vhosts</a></td>
<td><form action="nginx.php?op=logs" method="post" id="log">View the last?<br /><input type="text" name="l" value="25" autocomplete="off" /><br /><a href="nginx.php?op=logs" onClick="clog();return false;">View Log</a></form></td>
</tr>
</table><br />
<?php
$op = &$_GET['op'];
switch($op) {
case "restart": echo "<p style=\"color: #009\"><b>Restarting Nginx...</b></p>"; ejecutar("restart"); echo "<p style=\"color: #009\"><b>Done...</b></p>"; break;
case "edit":
if(isset($_POST['conf'])) {
$conf = $_POST['conf'];
file_put_contents("/etc/nginx/nginx.conf", $conf);
echo "<p><b>Configuration has been updated.</b></p>";
if(isset($_POST['c'])) { ejecutar("restart"); }
}
?>
<form action="nginx.php?op=edit" method="post" id="okay"><textarea name="conf" cols="80" rows="20"><?=shell_exec("cat /etc/nginx/nginx.conf")?></textarea><br />Restart Nginx? <input type="checkbox" name="c" /><br /><br /><input type="submit" value="Update!" onClick="okay();return false;" /></form>
<?
break;
case "rebuild": ejecutar("rebuild"); break;
case "logs":
if(empty($_POST['l'])) {
$var = shell_exec("cat /var/log/nginx/error.log");
$l = null;
} else {
$l = ereg_replace("/[0-9]/","",$_POST['l']);
$var = shell_exec("tail -{$l} /var/log/nginx/error.log");
}
echo "<p style=\"color: #009\"><b>Log Viewer - Showing Last {$l} Lines</b></p>";
echo "<pre>{$var}</pre>";
break;
case "httpd": 
echo "<p style=\"color: #009\"><b>Apache Status:</b></p>";
ejecutar("httpd"); break;
default:
$run = "Down";
$var = shell_exec("ps -A");
if(strstr($var,"nginx")) { $run = "UP"; }
echo "Nginx Service Status: <font style=\"color: #0c0\"><b>{$run}</b></font>";
?>
<p style="color: #03F"><b>About Nginx Admin</b></p>
<p>Nginx Admin is WHM interface of Nginx installer for cPanel server. This plugin will increase your server performance and decrease the server Apache Load. So you can host more websites in a cPanel server than usual. <br>Nginx is known for its high performance, stability, rich feature set, simple configuration, and low resource consumption. <br> Unlike traditional servers, Nginx doesn't rely on threads to handle requests. Instead it uses a much more scalable event-driven architecture. This architecture uses small, but more importantly, predictable amounts of memory under load. <br></p>
<? } ?>
<p>Nginx Admin: v<?php echo $cpAppVersion; ?></p><p>©2006-2010, <a href="http://www.nginxcp.com" target='_blank'>NginxCP.com</a></p>
</div>
</body>
</html>
